<template>
  <div id="class_board_wrapper" class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 16px; margin-bottom: 32px;" separator=">">
      <template v-if="authType">
        <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined && currentTeachingClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined && currentStudyingClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined && currentPreviewClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentOpenPreviewClass(classId) !== undefined && currentOpenPreviewClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentOpenPreviewClass(classId).name }}</el-breadcrumb-item>
      </template>
      <template v-if="!authType">
        <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined && currentTeachingClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined && currentStudyingClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined && currentPreviewClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentOpenPreviewClass(classId) !== undefined && currentOpenPreviewClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentOpenPreviewClass(classId).name }}</el-breadcrumb-item>
      </template><el-breadcrumb-item>{{ $t('CLASS_MENU.BOARD') }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
        </a>
      </div> 
    </el-breadcrumb>
    <el-form :model="input" label-width="120px" label-position="left">
      <el-form-item label="제목" prop="name" id="name">
        <el-input :placeholder="$t('BOARD.ENTER_POST_TITLE')" v-model="input.name" style="width: 60%"></el-input>
      </el-form-item>
      <el-form-item label="파일업로드" prop="fileUplode" id="fileUplode">
        <el-upload
        class="upload-demo"
        action="#"
        :on-remove="handleRemove"
        :before-remove="beforeRemove"
        multiple
        :limit="3"
        :on-exceed="handleExceed"
        :http-request="doUpload">
        <el-button size="small" type="primary">{{ $t('BOARD.UPLOAD_FILE') }}</el-button>
        <el-button size="small" type="text"> &#42; {{ $t('MATERIAL.NOTYPE') }} </el-button>
      </el-upload>
      </el-form-item>
    </el-form>

    <hr>

    <editor-menu-bar :editor="editor">
      <div class="menubar" slot-scope="{ commands, isActive }">
        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.bold() }"
          @click="commands.bold"
          style=""
        >
          <i class="board-icons board-btn1"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.italic() }"
          @click="commands.italic"
        >
          <i class="board-icons board-btn2"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.strike() }"
          @click="commands.strike"
        >
          <i class="board-icons board-btn3"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.underline() }"
          @click="commands.underline"
        >
          <i class="board-icons board-btn4"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.paragraph() }"
          @click="commands.paragraph"
        >
          <i class="board-icons board-btn6"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.heading({ level: 3 }) }"
          @click="commands.heading({ level: 3 })"
        >
          <i class="board-icons board-btn7"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.heading({ level: 2 }) }"
          @click="commands.heading({ level: 2 })"
        >
          <i class="board-icons board-btn8"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.heading({ level: 1 }) }"
          @click="commands.heading({ level: 1 })"
        >
          <i class="board-icons board-btn9"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.bullet_list() }"
          @click="commands.bullet_list"
        >
          <i class="board-icons board-btn10"></i>
        </button>

        <button
          class="menubar__button"
          :class="{ 'is-active': isActive.ordered_list() }"
          @click="commands.ordered_list"
        >
          <i class="board-icons board-btn11"></i>
        </button>

        <button
          class="menubar__button"
          @click="commands.undo"
        >
          <i class="board-icons board-btn13"></i>
        </button>

        <button
          class="menubar__button"
          @click="commands.redo"
        >
          <i class="board-icons board-btn14"></i>
        </button>

      </div>
    </editor-menu-bar>
    <hr>
    <editor-content :editor="editor" :style="`height: ${height}; overflow-y: scroll`"/>

    <!-- <div id="editor" ref="editor">
    </div> -->
    <!-- <el-button @click="test()">test!!</el-button> -->

    <!-- <div>
      <el-upload
        class="upload-demo"
        action="#"
        :on-remove="handleRemove"
        :before-remove="beforeRemove"
        multiple
        :limit="3"
        :on-exceed="handleExceed"
        :http-request="doUpload">
        <el-button size="small" type="primary">{{ $t('BOARD.UPLOAD_FILE') }}</el-button>
        <el-button size="small" type="text"> &#42; {{ $t('MATERIAL.NOTYPE') }} </el-button>
      </el-upload>
    </div> -->
    <div v-if="storedFileList.length > 0">
      <hr>
      <h4>{{ $t('BOARD.ATTACH_FILE') }}</h4>
      <div :key="file.file_guid" v-for="file in storedFileList" style="margin: 20px 0px 20px 10px;">
        <span>{{ $t('MATERIAL.NAME') }} : {{ file.name }} </span>
        <el-button type="danger" @click="onClick('DELETEFILE',file.file_guid)">X</el-button>
      </div>
    </div>
    <hr>
    <div>
      <el-button @click="onClick('WRITE')" plain>{{ $t('BOARD.SAVE') }}</el-button>
      <el-button @click="onClick('CANCEL')" plain>{{ $t('BOARD.CANCEL') }}</el-button>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex';
import { Editor, EditorContent, EditorMenuBar } from 'tiptap';
import {
  Blockquote,
  CodeBlock,
  HardBreak,
  Heading,
  OrderedList,
  BulletList,
  ListItem,
  TodoItem,
  TodoList,
  Bold,
  Code,
  Italic,
  Link,
  Strike,
  Underline,
  History,
} from 'tiptap-extensions';
import utils from '../../utils';

export default {
  components: {
    EditorMenuBar,
    EditorContent,
  },
  created() {
    const vm = this;
    if (vm.modifyMode === true) {
      // 이상한 경로로 접근하는 경우 vuex에 값이 남아있을 수도 있을것 같아서 가급적 component.$data로 옮겨서 사용합니다.
      vm.setModifyMode({ flag: false });
      vm.$data.ModifyMode = true;
      vm.$data.input.name = vm.post.name;
      vm.$data.content = vm.post.content;
      vm.editor.setContent(vm.post.content);
      vm.$data.storedFileList = vm.post.files;
    }
    let height = window.innerHeight || document.body.clientHeight;
    vm.height = `${(height * 0.35)}px`;
  },
  beforeDestroy() {
    const vm = this;
    vm.editor.destroy();
  },
  computed: {
    ...mapState('board', [
      'modifyMode',
      'post',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
      'currentStudyingClass',
      'currentPreviewClass',
      'currentOpenPreviewClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
  },
  methods: {
    ...mapActions('board', [
      'postPost',
      'setModifyMode',
      'modifyPost',
      'postFile',
      'deleteFile',
      'postFileWithID',
    ]),
    test() {
      const vm = this;
      // console.log('getHTML = ', vm.editor.getHTML());
      vm.editor.setContent('<h1>이 영역은 글을 쓸 수 있는 영역입니다.</h1><p>This is an area where you can write. :D</p>');
    },
    async onClick(type, arg) {
      const vm = this;
      switch (type) {
        case 'WRITE': {
          const content = vm.editor.getHTML();
          // fileUidGuidMap를 기반으로 GuidList를 생성
          const fileGuidList = [];
          this.$data.fileUidGuidMap.forEach((element) => {
            fileGuidList.push(element.guid);
          });
          if (vm.$data.ModifyMode === true) {
            await vm.modifyPost({
              classId: this.$route.params.classId,
              name: vm.$data.input.name,
              content,
              fileGuid: fileGuidList,
              boardId: vm.post.board_id,
            });
          } else {
            await vm.postPost({
              classId: this.$route.params.classId,
              name: vm.$data.input.name,
              content,
              fileGuid: fileGuidList,
            });
          }
          vm.$router.push(`/a/class/${this.$route.params.classId}/NNboard/0`);
          break;
        }
        case 'CANCEL': {
          vm.$router.go(-1);
          break;
        }
        case 'DELETEFILE': {
          const res = await vm.deleteFile({
            fileGuid: arg,
          });
          if (res.data.success !== true) {
            break;
          }
          vm.$data.storedFileList.forEach((element, index) => {
            if (element.file_guid === arg) {
              vm.$data.storedFileList.splice(index, 1);
            }
          });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    handleRemove(file) {
      // 파일 삭제 시, GuidMap 에서도 해당 파일 삭제
      this.$data.fileUidGuidMap.forEach((element, index) => {
        if (element.uid === file.uid) {
          this.$data.fileUidGuidMap.splice(index, 1);
        }
      });
    },
    handleExceed(files, fileList) {
      this.$message.warning(`The limit is 3, you selected ${files.length} files this time, add up to ${files.length + fileList.length} totally`);
    },
    beforeRemove(file) {
      return this.$confirm(this.$t('CONFIRM.WANT_RM') + ` ${file.name} ` + this.$t('CONFIRM.FILE'));
    },
    async doUpload(req) {
      if (this.$data.ModifyMode === false) {
        const res = await this.postFile({
          file: req.file,
        });
        this.$data.fileUidGuidMap.push({
          uid: req.file.uid,
          guid: res.data.fileGuid,
        });
      } else {
        const res = await this.postFileWithID({
          classId: this.$route.params.classId,
          boardId: this.post.board_id,
          file: req.file,
        });
        this.$data.fileUidGuidMap.push({
          uid: req.file.uid,
          guid: res.data.file.fileGuid,
        });
      }
    },
  },
  data() {
    return {
      name: '',
      content: '',
      ModifyMode: false, // 수정 상태라면 true, 쓰기로 들어왔다면 false
      fileUidGuidMap: [], // el-upload 에서 전해주는 uid 값과 node Server에서 반환받은 guid값을 연결할 용도로 사용
      storedFileList: [], // detail -> 수정 으로 넘어온 경우 기존에 갖고 있던 첨부파일 목록을 보관
      editor: new Editor({
        extensions: [
          new Blockquote(),
          new CodeBlock(),
          new HardBreak(),
          new Heading({ levels: [1, 2, 3] }),
          new BulletList(),
          new OrderedList(),
          new ListItem(),
          new TodoItem(),
          new TodoList(),
          new Bold(),
          new Code(),
          new Italic(),
          new Link(),
          new Strike(),
          new Underline(),
          new History(),
        ],
        content: `
          <h1>이곳은 글을 쓸 수 있는 영역입니다.</h1>
          <p>This is an area where you can write. :D</p>
        `,
      }),
      input: {
        name: '',
      },
      height: 0,
    };
  },
};
</script>


<style scoped>
.menubar__button {
  border: none;
  background: none;
}

.is-active {
  background: #d0d0d0;
}

.menubar__button:hover {
  background: #a0a0a0;
}

.board-icons {
  width: 20px;
  height: 20px;
  background-size: cover;
  display: inline-block;
}

.board-btn1 { background: url('../../assets/icon/bold.svg') no-repeat; }
.board-btn2 { background: url('../../assets/icon/italic.svg') no-repeat; }
.board-btn3 { background: url('../../assets/icon/strike.svg') no-repeat; }
.board-btn4 { background: url('../../assets/icon/underline.svg') no-repeat; }
.board-btn5 { background: url('../../assets/icon/code.svg') no-repeat; }
.board-btn6 { background: url('../../assets/icon/paragraph.svg') no-repeat; }
.board-btn7 { background: url('../../assets/icon/h3.svg') no-repeat; }
.board-btn8 { background: url('../../assets/icon/h2.svg') no-repeat; }
.board-btn9 { background: url('../../assets/icon/h1.svg') no-repeat; }
.board-btn10 { background: url('../../assets/icon/ul.svg') no-repeat; }
.board-btn11 { background: url('../../assets/icon/ol.svg') no-repeat; }
.board-btn12 { background: url('../../assets/icon/bold.svg') no-repeat; }
.board-btn13 { background: url('../../assets/icon/undo.svg') no-repeat; }
.board-btn14 { background: url('../../assets/icon/redo.svg') no-repeat; }
</style>

<style>  
.ProseMirror:focus {
  outline: none;
}
</style>